## gwt 2.4.0

=== plugins/Makefile ===
# Placeholder Makefile, to be replaced with ant build file

xpcom::
	cd xpcom; make
